% testing demo for the AVMP method
p = mfilename('fullpath'); %gives the fullname
fileDirectory = fileparts(p); %gives the directory of the current running m-file
cd(fileDirectory);
clear all;close all;clc
seedNumberArray = [1234 5678 55555 7777 8888];

global originalAudio
for j = 1:length(seedNumberArray),
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Generate the training AV data
    % step into the programme to see the synthetic data and atoms
    seedNumber = seedNumberArray(j);
    [audio video] = AVMPgenerateAVdata(40, 10, seedNumber); %% time and noise level and seednumber
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % get the audio spectrogram
    W = 512; NFFT = W; Hop = 0.25;%512 points at 16K Hz,  (32ms)
    [audio,originalAudio] = audioSpec(audio,NFFT,W,Hop);
    
    FrameShowL = 120;
    %     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %     % show the training AV data
    %     figure;
    %     if isvector(audio),
    %         ShowLength = min(round(FrameShowL/size(video,3)*length(audio)), length(audio));
    %         audioShow = audio(1:ShowLength);
    %     else
    %         ShowLength = min(round(FrameShowL/size(video,3)*size(audio,2)), size(audio,2));
    %         audioShow = dB(audio(:,1:ShowLength));
    %     end
    %     ShowLength = min(FrameShowL,size(video,3));
    %     videoShow = video(:,:,1:ShowLength);
    %     displayAVdata(audioShow,-videoShow,30,1,[0.6, 0.4 0],16000,30);
    
    
    
    %% Parameter Definition
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%*******************Must Pre-define*********************%%%%%%%%%%%
    atomNum = 5;                                % # atoms
    frame = 6;                                  % # frames for each AV atom
    videoAtomXY = [5 5];
    sizeVideoAtom = [videoAtomXY frame];    % size of the visual atom
    %%%%%%%%*****************optional to Pre-define****************%%%%%%%%%%%
    
    noOverlapBench = [1 5];
    noOverlapCell = {sizeVideoAtom-1, ceil(sizeVideoAtom*0.5)-1};
    
    iterStop = 9;
    atomsUsedNum = round(size(video,3)/frame);
    % find the patches where the video matching is ap plied.
    frameDynamic = frame;
    [scanIndex, videoVar] = initialScanIndex(audio, video, sizeVideoAtom, frameDynamic, 0.4);
    
    %     figure;
    %     ShowLength = min(FrameShowL,size(video,3));
    %     subplot(211)
    %     displayVideo(double(~scanIndex(:,:,1:ShowLength)),30);
    %     subplot(212)
    %     displayVideo(double(max(videoVar(:))-videoVar(:,:,1:ShowLength)),30);
    
    
    % similarityArray = [1 1];
    % thresholdBench = [2 4 6];
    % thresholdCell = {[0.001 0.01], [0.05 0.5], [0.1 0.5]};
    
    similarityArray = [1 2];
    thresholdBench = [2 4 6];
    thresholdCell = {[0.01 0.01], [0.05 0.5], [0.1 0.8]};
    
    % similarityArray = [3 2]; % 2 3
    % thresholdBench = [2 4 6];
    % thresholdCell = {[0.01 0.01], [0.5 0.5], [0.8 0.8]};
    
    P = parameterDef(audio, video, sizeVideoAtom, atomNum,...
        'scanIndex', scanIndex, 'iterStop', iterStop,...
        'thresholdBench',thresholdBench,'thresholdCell',thresholdCell,...
        'noOverlapBench', noOverlapBench, 'noOverlapCell', noOverlapCell,...
        'atomsUsedNum',atomsUsedNum,'similarityArray',similarityArray,...
        'figureMode', 1, 'figureIter', 1, 'saveMode', 1, 'saveIter', 5,...
        'seedNumber', seedNumber*10);
    
    
    % similarityArray = [3 2]; % correlation and SSIM
    % thresholdBench = [2 4 6];
    % realThresholdCell = {[0.01 0.1], [0.5 0.5], [0.8 0.8]};
    %
    % P = parameterDef(audio, video, sizeVideoAtom, atomNum,...
    %     'scanIndex',scanIndex,'iterStop', iterStop,...
    %     'thresholdBench',thresholdBench,'realThresholdCell',realThresholdCell,...
    %     'noOverlapBench',noOverlapBench,'noOverlapCell',noOverlapCell,...
    %     'atomsUsedNum',atomsUsedNum,'similarityArray',similarityArray,...
    %     'figureMode',1,'figureIter',1,'saveMode',1,'saveIter',5,...
    %     'seedNumber',seedNumber*10 );
    
    
    clc
    %%%%%%%*******************************************************%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Run the algorithm
    [Da Dv nn] = AVMP(audio, video, P);
    
%         %%%%% test the method
%         load Dictionary_010_12340.mat
%         showResult(ParamCoef,Da,-Dv,0,[],[],[0.3 0.5 0.15],16000,30,[600 300]);
%         timeFlag = 1; % show the audio signal in the time domain
%         showResult(ParamCoef,Da,-Dv,5,[],[],[0.3 0.5 0.15],16000,30,[600 300],timeFlag);
%         % load Dictionary_010.mat
%         % [Da,Dv] = ConvergeAtomFromResults(ParamCoef,Da,Dv,10);
%         % showD(Da,1-Dv,0,[],[],[0.3 0.5 0.15],16000,30,[600 300]);
    
end
