% testing demo for the AVMP method
p = mfilename('fullpath'); %gives the fullname
fileDirectory = fileparts(p); %gives the directory of the current running m-file
cd(fileDirectory);
clear all;close all;clc


seedNumberArray = [1234 5678 55555 7777 8888]; % for dictionary
seedNumArray = [412542 6358 9562 7884545 152 528649 2563256 847139 964821 7348656]; % for test data

Err_audio_rate = zeros(length(seedNumArray),length(seedNumberArray));
Err_video_rate = zeros(length(seedNumArray),length(seedNumberArray));

for j = 1:length(seedNumberArray),
    number = seedNumberArray(j)*10;
    saveName = ['Dictionary_000_',num2str(number,'%d'),'.mat'];
    load(saveName);
    [DaShow,DvShow,DaConverge,DvConverge] = ConvergeAtomFromResults(ParamCoef,Da,Dv);
    
    %     showResult(ParamCoef,Da,-Dv,0,[],[],[0.3 0.5 0.15],16000,30,[500 300]);
    
    %     showD(DaShow,DvShow,0,[],[],[0.3 0.5 0.15],16000,30,[600 300]);
    
    for i = 1:length(seedNumArray),
        %%%%%% test the method
        seedNum = seedNumArray(i);
        [audio video audio_AV video_AV] = AVMPgenerateAVdata(40,10,seedNum,[],1); %% time and noise level (0~0.3)
        
        PP = [];
        PP.Da = DaConverge;
        PP.Dv = DvConverge;
        PP.threshold = [0.1 0.4];
        sizeVideoAtom = size(Dv); 
        sizeVideoAtom = sizeVideoAtom(1:end-1); frame = sizeVideoAtom(end);
        frameDynamic = sizeVideoAtom(end);
        scanIndex = initialScanIndex(audio, video, sizeVideoAtom, frameDynamic, 0.4);
        PP.scanIndex = scanIndex;
        PP.atomsUsedNum = round(size(video,3)/frame);
        PP = parameterCoding(audio, video, PP);
        
        [ParamCoef Ra Rv notUse audio_Recover video_Recover] = coding_Monaci(audio,video,PP);
        
        % Error calculation
        Err_audio = audio_Recover - audio_AV;
        Err_audio_rate(i,j) = norm(Err_audio,'fro')^2/norm(audio_AV,'fro')^2;
        
        Err_video = video_Recover - video_AV;
        Err_video_rate(i,j) = norm(Err_video(:),'fro')^2/norm(video_AV(:),'fro')^2;
        
    end
end

saveName = 'PerformanceAVDL.mat';
save(saveName,'Err_audio_rate','Err_video_rate');