clear all;close all;clc

load PerformanceAVDL_Monaci.mat
x = Err_audio_rate(:);
y = Err_video_rate(:);

figure;
% hh1 = plot(x,y,'r+');
hh1 = plot(x,y,'o','MarkerEdgeColor','k','MarkerFaceColor',[.49 1 .63],'MarkerSize',8);

a1 = mean(x); v1 = mean(y);
xy = [x,y]; 
mus = mean(xy);
covars = xy - repmat(mus,[length(x),1]);
covars = covars'*covars/length(x);
hold on; 
Ellipse_plot(inv(covars(:,:))/3,mus(:),[.49 1 .63]);

 
load PerformanceAVDL.mat
x = Err_audio_rate(:);
y = Err_video_rate(:);

hh2 = plot(x,y,'^','MarkerEdgeColor','k','MarkerFaceColor',[.65 .36 .88],'MarkerSize',8);

a2 = mean(x); v2 = mean(y);
xy = [x,y];
mus = mean(xy);
covars = xy - repmat(mus,[length(x),1]);
covars = covars'*covars/length(x);
hold on; 
Ellipse_plot(inv(covars(:,:))/3,mus(:),[.65 .36 .88]);


legend([hh1,hh2],{'Monaci','AVDL'},'Location','SouthEast');

% xlabel('Error rate of the audio stream.','fontsize',14);
xlabel('','fontsize',14);
ylabel('Visual approximation error metric \epsilon^v','fontsize',14);

grid on

(a1 - a2)/a1
(v1 - v2)/v1


load PerformanceAVDL_Monaci.mat
y1 = Err_audio_rate(:);
y2 = Err_video_rate(:);
load PerformanceAVDL.mat
y11 = Err_audio_rate(:);
y22 = Err_video_rate(:);
x = 1:50;

figure
SH1 = subplot(211)
[AX,H1,H2] = plotyy(x,y1,x,y2,'plot');
set(get(AX(1),'Ylabel'),'String','Audio approximation error metric \epsilon^a','fontsize',14) 
set(get(AX(2),'Ylabel'),'String','Visual approximation error metric \epsilon^v','fontsize',14) 
set(AX(1),'ylim',[0.1 0.45],'ytick',[0.1:0.05:0.45],'xticklabel',[])
set(AX(2),'ylim',[0.1 0.45],'ytick',[0.1:0.05:0.45],'xticklabel',[])
ylabh = get(AX(1),'YLabel');
set(ylabh,'Position',get(ylabh,'Position') - [0 .2 0]);
ylabh = get(AX(2),'YLabel');
set(ylabh,'Position',get(ylabh,'Position') - [0 .2 0]);


title('Cases ranked by error','fontsize',14);
set(H1,'LineStyle','-','Marker','o','MarkerEdgeColor','k','MarkerFaceColor',[1 .7 .5],'MarkerSize',6)
set(H2,'LineStyle','-','Marker','^','MarkerEdgeColor','k','MarkerFaceColor',[1 .7 .5],'MarkerSize',6)
legend([H1,H2],{'Monaci \epsilon^a','Monaci \epsilon^v'},'Location','best');
grid on


SH2 = subplot(212)
[AX,H11,H22] = plotyy(x,y11,x,y22,'plot');
% set(get(AX(1),'Ylabel'),'String','Audio approximation error metric \epsilon^a','fontsize',14) 
% set(get(AX(2),'Ylabel'),'String','Visual approximation error metric \epsilon^v','fontsize',14) 
set(AX(1),'ylim',[0.1 0.45],'ytick',[0.1:0.05:0.45])
set(AX(2),'ylim',[0.1 0.45],'ytick',[0.1:0.05:0.45])


xlabel('Test index','fontsize',14) 
set(H11,'LineStyle','-','Marker','o','MarkerEdgeColor','k','MarkerFaceColor',[.65 .36 .88],'MarkerSize',6)
set(H22,'LineStyle','-','Marker','^','MarkerEdgeColor','k','MarkerFaceColor',[.65 .36 .88],'MarkerSize',6)
legend([H11,H22],{'AVDL   \epsilon^a','AVDL   \epsilon^v'},'Location','best');
grid on

set(SH1,'position',[0.1,0.53,0.8,0.4]);
set(SH2,'position',[0.1,0.1,0.8,0.4]);



load PerformanceAVDL_Monaci.mat
y1 = Err_audio_rate(:);
y2 = Err_video_rate(:);
load PerformanceAVDL.mat
y11 = Err_audio_rate(:);
y22 = Err_video_rate(:);
x = 1:50;
meanValue = (y11+y22)/2;
[useless, I] = sort(meanValue,1,'ascend');

figure
[AX,H1,H2] = plotyy(x,y1(I),x,y2(I),'plot');
set(AX(1),'ylim',[0.05 0.42],'ytick',[0.1:0.05:0.42],'xticklabel',[])
set(AX(2),'ylim',[0.05 0.42],'ytick',[0.1:0.05:0.42],'xticklabel',[])

% 
set(H1,'LineStyle','-','Marker','o','MarkerEdgeColor','k','MarkerFaceColor',[1 .7 .5],'MarkerSize',6)
set(H2,'LineStyle','-','Marker','^','MarkerEdgeColor','k','MarkerFaceColor',[1 .7 .5],'MarkerSize',6)
grid on

hold on
[AX,H11,H22] = plotyy(x,y11(I),x,y22(I),'plot');
title('Cases ranked by error','fontsize',14);
set(get(AX(1),'Ylabel'),'String','Audio approximation error metric \epsilon^a','fontsize',14) 
set(get(AX(2),'Ylabel'),'String','Visual approximation error metric \epsilon^v','fontsize',14) 
set(AX(1),'ylim',[0.05 0.42],'ytick',[0.1:0.05:0.42])
set(AX(2),'ylim',[0.05 0.42],'ytick',[0.1:0.05:0.42])
xlabel('Test index','fontsize',14) 
xlabh = get(AX(1),'XLabel');set(xlabh,'Position',get(xlabh,'Position') - [0 .01 0]);
xlabh = get(AX(2),'XLabel');set(xlabh,'Position',get(xlabh,'Position') - [0 .01 0]);
set(H11,'LineStyle','-','Marker','o','MarkerEdgeColor','k','MarkerFaceColor',[.65 .36 .88],'MarkerSize',6)
set(H22,'LineStyle','-','Marker','^','MarkerEdgeColor','k','MarkerFaceColor',[.65 .36 .88],'MarkerSize',6)
legend([H11,H22,H1,H2],{'AVDL   \epsilon^a','AVDL   \epsilon^v','Monaci \epsilon^a','Monaci \epsilon^v'},'Location','best');
grid on


