% testing demo for the AVMP method
p = mfilename('fullpath'); %gives the fullname
fileDirectory = fileparts(p); %gives the directory of the current running m-file
cd(fileDirectory);
clear all;close all;clc


seedNumberArray = [1234 5678 55555 7777 8888]; % for dictionary
seedNumArray = [412542 6358 9562 7884545 152 528649 2563256 847139 964821 7348656]; % for test data



for j = 1:length(seedNumberArray),
    number = seedNumberArray(j)*10;
    saveName = ['Dictionary_000_',num2str(number,'%d'),'.mat'];
    load(saveName);
    [DaShow,DvShow,DaConverge,DvConverge] = ConvergeAtomFromResults(ParamCoef,Da,Dv);
    

    
    speed=0;
    miss=0;
    for i = 1:length(seedNumArray),
        %%%%%% test the method
        seedNum = seedNumArray(i);
        [audio video audio_AV video_AV realscan] = AVMPgenerateAVdata(40,10,seedNum); %% time and noise level (0~0.3)
        
        PP = [];
        PP.Da = DaConverge;
        PP.Dv = DvConverge;
        PP.threshold = [0.1 0.4];
        sizeVideoAtom = size(Dv); 
        sizeVideoAtom = sizeVideoAtom(1:end-1); frame = sizeVideoAtom(end);
        frameDynamic = sizeVideoAtom(end);
        scanIndex = initialScanIndex(audio, video, sizeVideoAtom, frameDynamic, 0.4);
        
        temp = double(scanIndex); temp = temp(:);
        speed = speed+sum(temp/length(temp));
        
        Ys = size(realscan,1)+1-sizeVideoAtom(1);
        Xs = size(realscan,2)+1-sizeVideoAtom(2);
        Zs = size(realscan,3)+1-sizeVideoAtom(3);
        realscan = realscan(1:Ys,1:Xs,1:Zs);
        realscan = realscan>0;
        
        scanIndex1 = zeros(size(scanIndex));
%         scanIndex2 =scanIndex1;
        scanIndex1(:,:,1:end-1) = scanIndex(:,:,2:end);
%         scanIndex2(:,:,2:end) = scanIndex(:,:,1:end-1);
%         scanIndex = scanIndex1 | scanIndex2 | scanIndex;
        scanIndex = scanIndex1 | scanIndex;
        informationkeep = scanIndex(realscan);
        temp = double(informationkeep);
        temp = sum(temp)/length(temp)
        miss = miss+temp;

    end
    speed = speed/length(seedNumArray)
    miss = miss/length(seedNumArray)
end
