function [Da Dv] = atomInit(sizeAudioAtom,sizeVideoAtom,atomNum, video, similarityArray, seedNumber)
% Qingju Liu, University of Surrey
% Randomly generate the intialized audio atoms

if nargin<6,
    seedNumber = 4521325;
end
% randn('seed',seedNumber + 666666);

Da = InitializeAtom(sizeAudioAtom,atomNum,seedNumber*2);



if similarityArray(2)==99, % specially for visual speech training in the frequency domain,
    Dv1 = rand([sizeVideoAtom(:)' atomNum]);
    % YXZsearch
    [Vr Vc Frame] = size(video);
    [dvr dvc frame Nk] = size(Dv1);
    ySearch = Vr-dvr+1;
    xSearch = Vc-dvc+1;
    zSearch = Frame-frame+1;
    for i = 1:atomNum,
        temp = rand(1,3);
        index_y = max(1, round(temp(1)*ySearch));
        index_x = max(1, round(temp(2)*xSearch));
        index_z = max(1, round(temp(3)*zSearch));
        Dv1(:,:,:,i) = video(index_y+[0:dvr-1],index_x+[0:dvc-1],index_z+[0:frame-1]);
    end
    Dv = Dv1;
else
    Dv = InitializeAtom(sizeVideoAtom,atomNum,seedNumber*4);
end


function D = InitializeAtom(size_atom,atomNum,seedNumber)
rand('seed',seedNumber)
D = rand([size_atom(:)' atomNum]);
% normalization to get l2 unit norm
temp = size(D);

temp1=temp(1:end-1);
atomLength = prod(temp1);
D = reshape(D, [atomLength atomNum]);
D = D./repmat(sqrt(sum(D.^2)),atomLength,1);
D = reshape(D,temp);


