function AtomP = atomProjectPara(P)

AtomP.audioFlag = P.audioFlag;
AtomP.scanIndex = P.scanIndex;
AtomP.hopSize = P.hopSize;
AtomP.frameStartEnd = P.frameStartEnd;
AtomP.similarityArray = P.similarityArray;
AtomP.dispMode = P.dispMode;
AtomP.FsaVsFsv = P.FsaVsFsv;
AtomP.sizeAudioAtom = P.sizeAudioAtom;
AtomP.sizeVideoAtom = P.sizeVideoAtom;
AtomP.yxzSearch = P.yxzSearch;
AtomP.dar = P.dar;
AtomP.nint = P.nint;
AtomP.u1 = P.u1;
AtomP.sigma1_sqr = P.sigma1_sqr;

if isempty(P.realThreshold),
    AtomP.realThreshold = []; % calculate the realThresholds from the maximum values
    AtomP.threshold = P.threshold;
    % Find the largest audio similarity in the previous iteration
    
    maxCa = 0;
    maxCv = 0;
    if ~isempty(P.paramsOld)
        paramsOld = P.paramsOld;
        Nk = P.atomNum;
        projectionIndex = P.projectionIndex;
        for k=1:Nk,
            if projectionIndex(1,k)==0,
                maxCa = max(maxCa, max(paramsOld{k}.Ca));
            end
            if projectionIndex(2,k)==0,
                temp = paramsOld{k}.Cv;
                maxCv = max(maxCv, max(temp(:)));
            end
        end
    end
    AtomP.maxCa = maxCa;
    AtomP.maxCv = maxCv;
else
    AtomP.realThreshold = P.realThreshold;
end



%% Theses parameters for AtomP still need to be defined, changing with different dictionary atom
%%% AtomP.da AtomP.dv AtomP.projectionIndex AtomP.paramsOld
%%% AtomP.affectedCoordinates AtomP.u_dv AtomP.sigma_dv_sqr


