function stationary = detectStationary(AtomIndex,nn,AtomIndexOld,nnOld,AtomIndexOldOld,nnOldOld,stationary,dispmode)
% QINGJU LIU, University of Surrey
if nargin<8,dispmode = 1;end
if nargin<7,stationary = 0;end

subStationaryFlag = detectStationaryFlag(AtomIndex,nn,AtomIndexOld,nnOld,dispmode);
if ~subStationaryFlag,
    subStationaryFlag = detectStationaryFlag(AtomIndex,nn,AtomIndexOldOld,nnOldOld,dispmode);
end
if subStationaryFlag,
    stationary = stationary+1;
else
    stationary = 0;
end
switch stationary
    case 0
        fprintf(' #Coefficients repetitions = %d times:( \n', stationary);
    otherwise
        fprintf(' #Coefficients repetitions = %d times:) \n', stationary);
end


function stationaryFlag = detectStationaryFlag(AtomIndex,nn,AtomIndexOld,nnOld,dispmode)
if nargin<5,dispmode = 1;end

stationaryFlag = false;
if isempty(AtomIndex) || isempty(AtomIndexOld),
    stationaryFlag = false;
else
    TotalAtomNum = sum(nn);
    TotalAtomNumOld = sum(nnOld);
    if abs(TotalAtomNumOld-TotalAtomNum)>round(0.02*min(TotalAtomNum,TotalAtomNumOld)),
        stationaryFlag = false;
    else
        SimilarAtomNum = 0;
        for i = 1:length(AtomIndex),
            k = AtomIndex(i);
            n_k = nn(i);
            [C,IA,IB] = intersect(k,AtomIndexOld);
            if ~isempty(IB),
                SimilarAtomNum = SimilarAtomNum+min(nnOld(IB),n_k);
            end
        end
        
        threshold = TotalAtomNum;
        
        
        if SimilarAtomNum>=threshold,
            stationaryFlag = true;
        end
    end
    
    if dispmode && stationaryFlag
        fprintf(' With %f similar atoms \n', SimilarAtomNum/TotalAtomNum);
    end
    
end

