function P = parameterLearning(Ra, Rv, P)
%% First Define all the fields in the parameter structure P to avoid insufficient parameter for learning

%% Mandatory Fields: P.Da P.Dv
if ~isfield(P, 'Da') || ~isfield(P, 'Dv')
    error('Parameters contains at least the Dictionary!');
end
if isempty(P.Da) || isempty(P.Dv),
    error('Dictionary cannot be empty!');
end

%% Optional Fields: audioFlag,thresholdNum,atomMinNumUse,similarityArray,dispMode,scanIndex FsaVsFsv

[Vr Vc Frame] = size(Rv);
[dvr dvc frame Nk] = size(P.Dv);
%%% P.audioFlag
if isfield(P,'audioFlag') && ~isempty(P.audioFlag),
else
    if numel(Ra) == length(Ra),   % 1 D
        P.audioFlag = 1;
    else                                % 2 D
        P.audioFlag = 2;
    end
end

%%% P.atomNum
P.atomNum = Nk;

%%% P.thresholdNum
if ~isfield(P,'thresholdNum'),
    P.thresholdNum = [];
end

%%% P.atomMinNumUse
if isfield(P,'atomMinNumUse') && ~isempty(P.atomMinNumUse),
else
    P.atomMinNumUse = 1;
end

%%% P.varThreshold
if isfield(P,'varThreshold') && ~isempty(P.varThreshold),
else
    P.varThreshold = 0.3;
end

%%% P.similarityArray
if isfield(P,'similarityArray') && ~isempty(P.similarityArray),
else
    P.similarityArray = [1 1];
end

%%% P.scanIndex 
if isfield(P,'scanIndex') && ~isempty(P.scanIndex)
else
    P.scanIndex = ones(Vr-dvr+1, Vc-dvc+1, Frame-frame+1);
end

%%% P.dispMode
if isfield(P,'dispMode') && ~isempty(P.dispMode),
else
    P.dispMode = 1;
end

%%% P.FsaVsFsv
if isfield(P,'FsaVsFsv') && ~isempty(P.FsaVsFsv),
else
    if P.audioFlag==1,                  % 1D
        audioLength = length(audio);
    else
        audioLength = size(audio,2);
    end
    P.FsaVsFsv = audioLength/Frame;
end

