function [audioTF,originalAudio] = audioSpec(audio,NFFT,W,Hop)
% synchronised audio spectrum.
if nargin<2, NFFT = 512;end
if nargin<3, W = NFFT;end
if nargin<4, Hop = 0.25;end

audioTF = stft(audio, NFFT,W,Hop);
% audio1 = audioTF.*conj(audioTF);%PSD
% The synchronisation is very important:
H = round(W*Hop);% hopsize
T = size(audioTF,2);
StartAudioIndex = ceil(round(0.5*W)/H);
EndAudioIndex = StartAudioIndex + (T-1);
K = round(length(audio)/H);
originalAudio = audioTF(:,[ones(1,(StartAudioIndex-1)),1:end,ones(1,(K-EndAudioIndex))]);
audioTF = abs(originalAudio);