function newVideo = videoSpacialWhitening(video,f0)
if nargin<2 
    f0 = 0.8;
end


[M N Frame] = size(video);
% if mod(M,2)~=0,M=M+1;end;
% if mod(N,2)~=0,N=N+1;end;
% spacial filter
if mod(N,2)==0,
    fx = -N/2:N/2-1;
else
    fx = -(N-1)/2:(N-1)/2;
end
if mod(M,2)==0,
    fy = -M/2:M/2-1;
else
    fy = -(M-1)/2:(M-1)/2;
end

[fxx fyy] = meshgrid(fx,fy);
[theta rho] = cart2pol(fxx,fyy);
filt = rho;
% FiltS = filt.*exp(-0.5*((fx/(f0*N/2)).^2+(fy/(f0*M/2)).^2));

R = min(M,N)/2;
FiltS = filt.*exp(-0.5*(rho/(f0*R)).^2);
% imagesc(fx,fy,FiltS), axis image, colorbar


newVideo = zeros(M,N,Frame);

for i = 1:Frame,
    ftvideo = video(:,:,i);
    
    % spacial frequency domain
    ftvideo = fftshift(fft2(ftvideo));
    
    ftvideo = FiltS.*ftvideo;
    % back to spacial-time domain
    ftvideo = real(ifft2(ifftshift(ftvideo)));
    
    newVideo(:,:,i) = ftvideo;
end



