function newVideo = videoWhitening(video,f0,patchsize,HopSize)

[M N Frame] = size(video);
sigma = 1;
smask = fspecial('gaussian', ceil(3*sigma), sigma);
for frame = 1:Frame,
    temp = video(:,:,frame);
    temp = filter2(smask, temp, 'same');
    video(:,:,frame) = temp;
end

if nargin<4,
    HopSize = 0.25;
end

if nargin>3 && ~isempty(patchsize),
else
    patchsize = 100;
end
if nargin>2 && ~isempty(f0),
else
    f0 = 0.8;
end

if HopSize<1,
    SP=fix(patchsize.*HopSize);
end

nPatch=ceil((Frame-patchsize)/SP +1); %number of segments




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if mod(N,2)==0,
    fx = -N/2:N/2-1;
else
    fx = -(N-1)/2:(N-1)/2;
end
if mod(M,2)==0,
    fy = -M/2:M/2-1;
else
    fy = -(M-1)/2:(M-1)/2;
end
if mod(patchsize,2)==0,
    fz = -patchsize/2:patchsize/2-1;
else
    fz = -(patchsize-1)/2:(patchsize-1)/2;
end

[fxx fyy] = meshgrid(fx,fy);
[theta rho] = cart2pol(fxx,fyy);
R1 = min(M,N)/2;R2 = patchsize/2;
FiltS = rho.*exp( -0.5*(rho/(f0*R1)).^2 );
FiltS = repmat(FiltS,[1 1 patchsize]);
FiltT = abs(fz).*exp( -0.5*(fz/(f0*R2)).^2 );
FiltT = repmat(reshape(FiltT,[1 1 patchsize]),[M N 1]);
FiltS = FiltS.*FiltT;
% [fxx fyy fzz] = meshgrid(fx,fy,fz);
% slice(fxx,fyy,fzz,FiltS,0,0,[0 patchsize/4]), shading flat
% colorbar

shift = round((patchsize-SP)/2);
newVideo = zeros(M,N,Frame);
for i = 1:nPatch,
    if i<nPatch,
        frame_start = (i-1)*SP+1;
        frame_end = (i-1)*SP+patchsize;
    else
        frame_start = Frame-patchsize+1;
        frame_end = Frame;
    end
    ftVideo = video(:,:,frame_start:frame_end);
    
    % figure;displayVideo(ftVideo,10,1);
    ftVideo = fft(ftVideo,[],1);
    ftVideo = fft(ftVideo,[],2);
    ftVideo = fft(ftVideo,[],3);
    ftVideo = fftshift(ftVideo,3);
    ftVideo = fftshift(ftVideo,2);
    ftVideo = fftshift(ftVideo,1);
    
    ftVideo = FiltS.*ftVideo;
    
    ftVideo = ifft(fftshift(ftVideo,3),[],3);
    ftVideo = ifft(fftshift(ftVideo,2),[],2);
    ftVideo = ifft(fftshift(ftVideo,1),[],1);
    
    tVideo  = real(ftVideo);
    % videoShow = tVideo;
    % displayVideo(videoShow,10,1);
    
    if i==1,
        newVideo(:,:,frame_start:frame_end) = tVideo;
    elseif i<nPatch
        newVideo(:,:,frame_start+shift:frame_start+shift+SP-1) = tVideo(:,:,shift+1:shift+SP);
    else
        length_1 = Frame-(frame_start+shift+SP);
        newVideo(:,:,frame_start+shift+SP:end) = tVideo(:,:,end-length_1:end);
    end
end




