function displayVideo(video,Col,buf,colorScale)
% display a MxNxFrame video sequence
% the video values are distributed between ([0---1]) 0---black; 1 white)

video = double(video);
if isvector(video),
    video = reshape(video,[1 1 length(video)]);
end
M = size(video,1);
N = size(video,2);
Frame = size(video,3);

if nargin <4,
    min_val = min(video(:));
    max_val = max(video(:));
else
    min_val = colorScale(1);
    max_val = colorScale(2);
end

if min_val == max_val,
    min_val = max_val-1;
end

if nargin <3,
    buf=1;
end
if nargin <2,
    Col = Frame;
    Row=1;
else
    Col = min(round(abs(Col)),Frame);
    Row=ceil(Frame/Col);
end



if mean(video(:))<median(video(:)),
    array=ones(buf+Row*(M+buf),buf+Col*(N+buf))*min_val;
else
    array=ones(buf+Row*(M+buf),buf+Col*(N+buf))*max_val;
end
if all(video(:)==mean(video(:)));
    array=ones(buf+Row*(M+buf),buf+Col*(N+buf))*(video(1)-1);
end

k=1;


% clim=max(abs(video(:)));
for i=1:Row
    for j=1:Col
        if k<=Frame,
            temp = video(:,:,k);
            array(buf+(i-1)*(M+buf)+[1:M],buf+(j-1)*(N+buf)+[1:N])= temp;
%         else
%             array(buf+(i-1)*(M+buf)+[1:M],buf+(j-1)*(N+buf)+[1:N])= 1;
        end
        k=k+1;
    end
end

if exist('h','var')
    set(h,'CData',array);
else
	%h=imagesc(array,'EraseMode','none',[0 1]);
    h=imagesc(array,[min_val,max_val]);
    axis image
    colormap(gray(256))
    set(gca,'YTick',[],'YTickLabel',[]);
    set(gca,'XTick',[],'XTickLabel',[]);
end
drawnow