% Main
% Qingju Liu, University of Surrey
p = mfilename('fullpath'); %gives the fullname
fileDirectory = fileparts(p); %gives the directory of the current running m-file
cd(fileDirectory);
clear all;close all;clc

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% seedNumber = 123456;
%%%% first randomly generate mixtures with Hammonson database
% the target speaker azimuth angle is 0 degree, and the intering speaker
% azimuth [15 30 45 60 75 90] with each have 15 randomly truncated from s1
% and s2, eaching lasting 10 seconds (each AV is about 300 ms,
% therefore, we use long data for the MP of the coding stage)

room_array = [3];         % types of room
SNR_array = {10,[]};        % dB
azim_array = [15 30 45 60 75 90];
t_start = 15:15:225;


src_dir = '/vol/vssp/RobotAudition/Matlab/Data/ALL Data/';
addpath(src_dir)
for room_index = 1:length(room_array),
    roomType = room_array(room_index);
    fprintf('&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& RoomType is %d.\n', roomType);
    switch roomType,
        case 1
            RT_time = '0';
        case 2
            RT_time = '0_32';
        case 3
            RT_time = '0_47';
        case 4
            RT_time = '0_68';
        case 5
            RT_time = '0_89';
    end
    LLR_Mandel = zeros(15,length(azim_array),length(SNR_array));
    SDR_Mandel = LLR_Mandel;
    PESQ_Mandel = LLR_Mandel;
    
    LLR_AVDL = LLR_Mandel;
    SDR_AVDL = LLR_Mandel;
    PESQ_AVDL = LLR_Mandel;
    
    LLR_AVMP = LLR_Mandel;
    SDR_AVMP = LLR_Mandel;
    PESQ_AVMP = LLR_Mandel;
    
    LLR_AVLiu = LLR_Mandel;
    SDR_AVLiu = LLR_Mandel;
    PESQ_AVLiu = LLR_Mandel;
    
    PEASS_Mandel = cell(15,length(azim_array),length(SNR_array));
    PEASS_AVDL = PEASS_Mandel;
    PEASS_AVMP = PEASS_Mandel;
    PEASS_AVLiu = PEASS_Mandel;
    
    for SNR_index = 1:length(SNR_array),
        SNR = SNR_array{SNR_index};
        fprintf('************************************************SNR is [%d] dB. \n', SNR);
        for azim_index = 1:length(azim_array),
            azim = azim_array(azim_index);
            fprintf('================================Azimuth is %d.\n', azim);
            for k = 1:15,
                fprintf('++++++++++++++++++++++++++++++ %2d\n', k);
                writeName_s = ['s_room',num2str(roomType),'_SNR',num2str(SNR),'_azim',num2str(azim),'_',num2str(k),'.wav'];
                [s_origin,Fs] = wavread(writeName_s);
                writeName_s2 = ['s2_',num2str(k),'.wav'];
                s_origin2 = wavread(writeName_s2);
                writeName_x = ['x_room',num2str(roomType),'_SNR',num2str(SNR),'_azim',num2str(azim),'_',num2str(k),'.wav'];
                x = wavread(writeName_x);
                writeName_Mandel = ['y_room',num2str(roomType),'_SNR',num2str(SNR),'_azim',num2str(azim),'_',num2str(k),'_Mandel.wav'];
                y_Mandel = wavread(writeName_Mandel);
                writeName_AVDL = ['y_room',num2str(roomType),'_SNR',num2str(SNR),'_azim',num2str(azim),'_',num2str(k),'_AVDL.wav'];
                y_AVDL = wavread(writeName_AVDL);
                writeName_AVMP = ['y_room',num2str(roomType),'_SNR',num2str(SNR),'_azim',num2str(azim),'_',num2str(k),'_AVMP.wav'];
                y_AVMP = wavread(writeName_AVMP);
                writeName_AVLiu = ['y1_room',num2str(roomType),'_SNR',num2str(SNR),'_azim',num2str(azim),'_',num2str(k),'_AVLiu.wav'];
                y_AVLiu = wavread(writeName_AVLiu);
                
                
                
                %%%%%%%%%%%%
                % Set inputs
                %%%%%%%%%%%%
                src1_name = [src_dir, writeName_s];
                src2_name = [src_dir, writeName_s2];
                originalFiles = {src1_name;src2_name};
                estimateFile_Mandel = [src_dir, writeName_Mandel];
                estimateFile_AVDL = [src_dir, writeName_AVDL];
                estimateFile_AVMP = [src_dir, writeName_AVMP];
                estimateFile_AVLiu = [src_dir, writeName_AVLiu];
                
                %%%%%%%%%%%%%
                % Set options
                %%%%%%%%%%%%%
                options.destDir = src_dir;
                options.segmentationFactor = 1; % increase this integer if you experienced "out of memory" problems
                
                %%%%%%%%%%%%%%%%%%%%
                % Call main function
                %%%%%%%%%%%%%%%%%%%%
                PEASS_Mandel{k,azim_index,SNR_index} = PEASS_ObjectiveMeasure(originalFiles,estimateFile_Mandel,options);
                PEASS_AVDL{k,azim_index,SNR_index} = PEASS_ObjectiveMeasure(originalFiles,estimateFile_AVDL,options);
                PEASS_AVMP{k,azim_index,SNR_index} = PEASS_ObjectiveMeasure(originalFiles,estimateFile_AVMP,options);
                PEASS_AVLiu{k,azim_index,SNR_index} = PEASS_ObjectiveMeasure(originalFiles,estimateFile_AVLiu,options);
                
                
                %                 llr_temp = llr(s_origin,y_Mandel,Fs);
                %                 pesq_temp = pesq(Fs,writeName_s,writeName_Mandel);
                %                 sdr_temp = eval_sdr(y_Mandel,s_origin);
                %                 fprintf(['SDR=',num2str(sdr_temp,'%-5.5g'),'dB, PESQ=', num2str(pesq_temp,'%-5.5g'),', llr=', num2str(llr_temp,'%-5.5g'),'\n']);
                %                 LLR_Mandel(k,azim_index,SNR_index) = llr_temp;
                %                 PESQ_Mandel(k,azim_index,SNR_index) = pesq_temp;
                %                 SDR_Mandel(k,azim_index,SNR_index) = sdr_temp;
                %
                %                 llr_temp = llr(s_origin,y_AVDL,Fs);
                %                 pesq_temp = pesq(Fs,writeName_s,writeName_AVDL);
                %                 sdr_temp = eval_sdr(y_AVDL,s_origin);
                %                 fprintf(['SDR=',num2str(sdr_temp,'%-5.5g'),'dB, PESQ=', num2str(pesq_temp,'%-5.5g'),', llr=', num2str(llr_temp,'%-5.5g'),'\n']);
                %                 LLR_AVDL(k,azim_index,SNR_index) = llr_temp;
                %                 PESQ_AVDL(k,azim_index,SNR_index) = pesq_temp;
                %                 SDR_AVDL(k,azim_index,SNR_index) = sdr_temp;
                %
                %                 llr_temp = llr(s_origin,y_AVMP,Fs);
                %                 pesq_temp = pesq(Fs,writeName_s,writeName_AVMP);
                %                 sdr_temp = eval_sdr(y_AVMP,s_origin);
                %                 fprintf(['SDR=',num2str(sdr_temp,'%-5.5g'),'dB, PESQ=', num2str(pesq_temp,'%-5.5g'),', llr=', num2str(llr_temp,'%-5.5g'),'\n']);
                %                 LLR_AVMP(k,azim_index,SNR_index) = llr_temp;
                %                 PESQ_AVMP(k,azim_index,SNR_index) = pesq_temp;
                %                 SDR_AVMP(k,azim_index,SNR_index) = sdr_temp;
                %
                %                 llr_temp = llr(s_origin,y_AVLiu,Fs);
                %                 pesq_temp = pesq(Fs,writeName_s,writeName_AVLiu);
                %                 sdr_temp = eval_sdr(y_AVLiu,s_origin);
                %                 fprintf(['SDR=',num2str(sdr_temp,'%-5.5g'),'dB, PESQ=', num2str(pesq_temp,'%-5.5g'),', llr=', num2str(llr_temp,'%-5.5g'),'\n']);
                %                 LLR_AVLiu(k,azim_index,SNR_index) = llr_temp;
                %                 PESQ_AVLiu(k,azim_index,SNR_index) = pesq_temp;
                %                 SDR_AVLiu(k,azim_index,SNR_index) = sdr_temp;
                
            end
        end
        
    end
    
    saveName = ['Room_',num2str(roomType,'%d'),'.mat'];
    
    %     save(saveName,'LLR_Mandel', 'SDR_Mandel', 'PESQ_Mandel', 'LLR_AVDL', 'SDR_AVDL', 'PESQ_AVDL',...
    %         'LLR_AVMP', 'SDR_AVMP', 'PESQ_AVMP', 'LLR_AVLiu', 'SDR_AVLiu', 'PESQ_AVLiu', 'SNR_array','azim_array',...
    %         'PEASS_Mandel', 'PEASS_AVDL', 'PEASS_AVMP', 'PEASS_AVLiu');
    
    save(saveName,'PEASS_Mandel', 'PEASS_AVDL', 'PEASS_AVMP', 'PEASS_AVLiu');
    
end

