%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%								                                         %
%   Subject    : Generate complex Gaussian random noise w(n)      		 %
%		 for n=0, 1, ..., N-1											 %
%					                                            		 %
%																		 %
%   Software   : MATLAB for DOS 			                       		 %
%   Author     : Chih-Chun Feng 		                       			 %
%   Filename   : noise.m				                           		 %
%   Date       : 1996-10-1				                           		 %
%								                                       	 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function   [w]	=  noise(hnb,hna,x,SNR,SEED_NUMBER,STRING)

x = x(:);
N = length(x);
snr = 10^(SNR/10);

hn = filter(hnb,hna,[1;zeros(100,1)]);
Vws = sqrt( ((x'*x)/N) / (snr*hn'*hn) );


%rand('normal');
randn('seed',SEED_NUMBER);

if STRING == 'R',

   w1 = randn(N+200,1);

else

   if STRING == 'C',

      Vws = Vws / sqrt(2);
      w1_R = randn(N+200,1);
      w1_I = randn(N+200,1);
      w1 = w1_R + j*w1_I;

   else

      disp('Error usage of noise.m !');
      return;
  %break;
   end;

end;

w1 = filter(hnb,hna,Vws*w1);
w = w1(201:N+200,1);


